import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class Spline1 extends Frame
{  public int Iter,Itermax; public double Err;
   public Spline1()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double[] setQ(double[]X, int K, int N)   // Qݒ
   {  double []Q= new double[N + 2*(K-1)];
      double DX = X[1] - X[0]; Q[K - 2] = X[0] - DX;
      for(int i = K - 2; i>= 1; i--)  Q[i - 1]     = Q[i] - DX;
      for(int i = 1    ; i<= N; i++)  Q[i + K - 2] = X[i - 1];
      DX = X[N-1] - X[N - 2];
      for(int i = 1; i<= K - 1; i++)  Q[i + N + 2] = Q[i + N + 1] + DX;
      return Q;
   }
   public double[][] setArray(double[]Y, double[] Q, int K, int N) // zݒ
   {  double [][]A = new double[N][N+1];
      for(int i = 0; i< N; i++)
      {  for(int j = 0; j< N; j++) A[i][j] = Bspline(Q, j+1, K, Q[i + K - 2]);
         A[i][N] = Y[i];
      }
      return A;
   }
   public double [] setX(double Xstart,int NN, double DX) // Xݒ
   {  double []XX = new double[NN];
      XX[0] = Xstart - 1;
      for(int j = 1; j < NN ; j++)  XX[j] = XX[j - 1] + DX;
      return XX;
   }
   public double Bspline(double []Q, int i, int K, double X)
   { if(K == 1)
     { if     ( X < Q[i - 1]) return 0;
       else if( X < Q[i    ]) return 1;
       else                   return 0;
     } 
     else
     { double B1 = Bspline(Q, i    , K - 1, X);
       double B2 = Bspline(Q, i + 1, K - 1, X);
       return  (X           - Q[i - 1]) * B1 / (Q[i + K - 2] - Q[i - 1]) +
               (Q[i + K - 1]- X       ) * B2 / (Q[i + K - 1] - Q[i    ]);
     }
   }
   public double[] Inter(double [][]A, double []XX, double[]Q, int K, int N, int NN)  // Ԃ̌vZ
   { double []YY = new double[NN]; 
     for(int j = 0; j< NN; j++)
     {  double T = 0;
        for(int i = 0; i< N; i++) T += A[i][N] * Bspline(Q, i + 1, K, XX[j]);
        YY[j] = T;
     }
     return YY;
   }
   public int SimEq(double [][] A, int N, double Eps)
   {   int i,j,k; double Alfa; int N1=N+1;   
       for(k = 0; k < N; k++)     // Oi   
       { int k1=k+1; 
         double max=Math.abs(A[k][k]); int IR = k;  //s{bgI
         if(k != N) for(i=k1;i<N; i++)if(Math.abs(A[i][k])>max){max=Math.abs(A[i][k]);IR=i;}
         if(max < Eps) return 1;
         if(IR !=k ) for(j=k; j<N1;j++){Alfa=A[k][j]; A[k][j]=A[IR][j];A[IR][j]=Alfa;}
         for(i=k+1; i<N; i++)
         { Alfa= A[i][k] / A[k][k];
           for(j = k + 1;j <= N; j++)  A[i][j] -= Alfa * A[k][j];
       } }
       for(i = N-1; i >= 0; i--)   // ޑ
       {   Alfa = A[i][N];
           for(j = i + 1; j < N; j++) Alfa -= A[i][j] * A[j][N];
           A[i][N] = Alfa / A[i][i];
       }
       return 0;
   }
   public double[][] Interpolation(int K, double []X, double []Y, int N)
   { double []Q = setQ(X, K, N);
     double [][] A= setArray(Y,Q, K, N);
     int R=SimEq(A, N, 0.0001);
     double [][] XY=new double[2][41];
     XY[0] = setX( X[0], 41, 0.1);
     XY[1] = Inter(A, XY[0], Q, K, N, 41);
     return XY;
   }
   public int Xpos(double X)
   {  return (int)(X*100)+100;}
   public int Ypos(double Y)
   {  return 400- (int)(Y*50);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void paint(Graphics g)
   { double []  X = { 1,2,3,4,5};
     double []  Y = { 3,5,4,6,4};
     double [][]  XY= Interpolation(4, X, Y, 5);
     setTitle("XvCԁîPj");
     g.setColor(new Color(0,0,255));
     for(int i=0;i<=4;i++) drawLine(g,(double)i,0,(double)i,7);
     for(int i=0;i<=7;i++) drawLine(g,0,(double)i,4,(double)i);
     for(int i=1;i<=5;i++) g.drawString(""+i, i*100-4,Ypos(-0.4));
     for(int i=0;i<=7;i++) g.drawString(""+i, Xpos(-0.1),Ypos(i-0.1));
     
     g.setColor(new Color(255,0,0));
    
     for(int i=1;i<41;i++) drawLine(g,XY[0][i-1],XY[1][i-1],XY[0][i],XY[1][i]);
     for(int i=0;i<5;i++)  drawPoint(g,X[i]-1,Y[i]);
     
   } 
   public static void main(String[] args)
   {  Frame w = new Spline1();
      w.setVisible(true);
   }
}
